#!/bin/sh

logger -p user.info "Starting LassoService"

pid_file=/tmp/LassoService.pid
hour=-1
restartcounter=0
maxrestarts=20

while [ $restartcounter -lt $maxrestarts ]; do

	#	reset the counter each hour

	if [ $hour -ne `date +%H` ]; then
		restartcounter=0
		hour=`date +%H`
	fi

	#	Start up LassoService.  If it dies, we can see later if it was a clean quit or not

	HOME=/usr/local/Lasso\ Professional\ 7
	umask 002

	cd /usr/local/Lasso\ Professional\ 7/
	./LassoService 2> /dev/null >> /dev/null

	#	If there's a dangling pid file, that means we died unexpectedly

	if test -f "$pid_file"
	then
		restartcounter=$((restartcounter+1))
		logger -p user.info "LassoService restarted after quitting unexpectedly ${restartcounter} times this hour"
	else
		logger -p user.info "LassoService was shut down cleanly"
		restartcounter=0
		break
	fi

done

#	On exit, check why we're exiting  (if it's bad, let someone know)
if [ $restartcounter -eq $maxrestarts ]; then
	logger -p user.info "LassoService was restarted ${restartcounter} times in one hour, indicating a more serious configuration problem.  Quitting permanently now."
fi
