<!-- When the user selects one of the detail links from the listing page, Lasso serves this page to provide more detail about the particular record they selected. -->

[Include:'header.lasso']

<form action="undefined" method="POST">
	<table bgcolor="#FFFFFF" cellspacing="1" cellpadding="5" width="550" border="0">
		<tr>
			<td colspan="2"> <h2>Display Record</b></h2>
			
	<!-- The [Inline] LDML object performs a -Search or -FindAll action on the database in order to display record data. The [Inline] tag will display record data based on information submitted by a previous page. The [Action_Params] tag transfers all information submitted from a previous page. -->		
			
	[If: (Token_Value: 'Action') >> 'Find All'][Variable: 'Action'=-FindAll][Else][Variable: 'Action'=-Search][/If]
	[Inline: (Action_Params), -Database='Example_DB', -Table='web', -KeyField='id', -MaxRecords=1, $Action]
 </td>
		</tr>
		<tr>
		
	<!-- An [If] statement is used to display an error message if an error occurs when displaying the record, or if there are no records found. The [Error_CurrentError] tag displays the current Lasso error message. For more information on error tags, see Chapter 21 in the Lasso 7 Language Guide. -->
		
			<td colspan="2"> 	[If: (Error_CurrentError) != (Error_NoError)]An error has occurred. ([Error_CurrentError: -ErrorCode] [Error_CurrentError])
	[Else: (Found_Count) == 0]No Records Found[/If]
 </td>
		</tr>
		
	<!-- Record data is displayed via [Field] LDML objects. All [Field] LDML objects are contained within the [Inline] ... [/Inline] tags, which populates the [Field] objects with the record data returned from the database action. -->	
		
		<tr>
			<td><b> ID </b></td>
			<td> [Field: 'id'] </td>
		</tr>
		<tr>
			<td><b> Address </b></td>
			<td> [Field: 'address'] </td>
		</tr>
		<tr>
			<td><b> City </b></td>
			<td> [Field: 'city'] </td>
		</tr>
		<tr>
			<td><b> Company </b></td>
			<td> [Field: 'company'] </td>
		</tr>
		<tr>
			<td><b> Description </b></td>
			<td> [Field: 'description'] </td>
		</tr>
		<tr>
			<td><b> Phone </b></td>
			<td> [Field: 'phone'] </td>
		</tr>
		<tr>
			<td><b> State </b></td>
			<td> [Field: 'state'] </td>
		</tr>
		<tr>
			<td><b> URL </b></td>
			<td> [Field: 'url'] </td>
		</tr>
		<tr>
			<td><b> Zip </b></td>
			<td> [Field: 'zip'] </td>
		</tr>
		<tr>
			<td><b> Country </b></td>
			<td> [Field: 'country'] </td>
		</tr>
		<tr>
			<td colspan="2"> 
	[/Inline]
 </td>
		</tr>
	</table>
</form>

[Include:'footer.lasso']
