#ifndef _LASSO_DEFINES_H_
#define _LASSO_DEFINES_H_

static const char* kOpBegin/*[]*/ = "opbegin";
static const char* kOperatorBegin/*[]*/ = "operatorbegin";
static const char* kOpEnd/*[]*/ = "opend";
static const char* kOperatorEnd/*[]*/ = "operatorend";

static const UChar* kOpBeginW = LPW(L"opbegin");
static const UChar* kOperatorBeginW = LPW(L"operatorbegin");
static const UChar* kOpEndW = LPW(L"opend");
static const UChar* kOperatorEndW = LPW(L"operatorend");

// some internal variable keys
static const char* kHTTPHeader = "__http_header__";
static const char * kHTMLReply = "__html_reply__";
static const UChar * kHTTPHeaderW = LPW(L"__http_header__");
static const UChar * kHTMLReplyW = LPW(L"__html_reply__");

static const UChar * kOutputEncoding = LPW(L"__encoding__");
static const UChar * kInternalConverters = LPW(L"__internal_converters__");
static const UChar * kExternalConverters = LPW(L"__external_converters__");

// result code & message
static const char * kResultCode/*[]*/ = "__result_code__";
static const char * kResultMessage/*[]*/ = "__result_message__";

// the 'self' variable
static const UChar * kSelf/*[]*/ = LPW(L"self");

// the type name variable
static const UChar * kTypeName/*[]*/ = LPW(L"__type_name__");

// formatting flags
static const char * kFormattingFlags/*[]*/ = "lp_formatting_flags";
// valie parameters for formatting flags
static const UChar * kFlagScientific/*[]*/ = LPW(L"-scientific");
static const UChar * kFlagPrecision/*[]*/ = LPW(L"-precision");
static const UChar * kFlagDecChar/*[]*/ = LPW(L"-decimalchar");
static const UChar * kFlagPadding/*[]*/ = LPW(L"-padding");
static const UChar * kFlagPadChar/*[]*/ = LPW(L"-padchar");
static const UChar * kFlagPadRight/*[]*/ = LPW(L"-padright");
static const UChar * kFlagGroupChar/*[]*/ = LPW(L"-groupchar");
static const UChar * kFlagHexidecimal/*[]*/ = LPW(L"-hexadecimal");

// variables for email stuff
static const char * kEmailHost/*[]*/ = "__email_host__";
static const char * kEmailMimeType/*[]*/ = "__email_mimetype__";
static const char * kEmailResponse/*[]*/ = "__email_response__";
static const char * kEmailTo/*[]*/ = "__email_to__";
static const char * kEmailFrom/*[]*/ = "__email_from__";
static const char * kEmailCC/*[]*/ = "__email_cc__";
static const char * kEmailBCC/*[]*/ = "__email_bcc__";
static const char * kEmailSubject/*[]*/ = "__email_subject__";
static const char * kEmailAttachment/*[]*/ = "__email_attachment__";

static const char * kLassoServiceHost/*[]*/ = "__lassoservice_host__";
static const char * kLassoServiceIP/*[]*/ = "__lassoservice_ip__";

// the return value of a custom tag
// this is what gets returned by the return_value tag
static const char * kReturnValue/*[]*/ = "__return_value__";

// top level location of tag registry
//static const char * kTagRegistry/*[]*/ = "__tag_registry__";
// within that, location of substitution tags
static const char * kSubstitutionTags/*[]*/ = "__tags__";
// and for command tags
static const char * kCommandTags/*[]*/ = "__command__";

static const char * kParentContext/*[]*/ = "__parent_context__";

// name of the module serving as the storage host
static const char * kStorageHost/*[]*/ = "lasso_storage_host";

// suffix for site specific dbs
static const char * kSiteDBPrefix/*[]*/ = "lasso_site_";

// the variable name that the security guard is stored under
static const char * kLassoSecurity/*[]*/ = "lassoSecurity";

// the tag that can be called for the start of each new request
static const char * kOnRequestStart/*[]*/ = "onrequeststart";

// the current user's groups are cached at request start and stored as an array in this variable
static const char * kCurrentUserGroups/*[]*/ = "__current_user_groups__";

// the admins group id
static const char * kAdminsID/*[]*/ = "__admins_id__";
// the everybody id
static const char * kEverybodyID/*[]*/ = "__everybody_id__";

static const char * kAnonymous/*[]*/ = "ANONYMOUS";
static const char * kAdministrator/*[]*/ = "ADMINISTRATOR";

// name of the default command tag
static const char * kDefaultCommandTag/*[]*/ = "default_command_tag";

static const UChar * kPreCondition/*[]*/ = LPW(L"precondition");
static const UChar * kPostCondition/*[]*/ = LPW(L"postcondition");
static const UChar * kHandle/*[]*/ = LPW(L"handle");

// base type names
static const UChar * kNull/*[]*/ = LPW(L"null");
static const UChar * kInteger/*[]*/ = LPW(L"integer");
static const UChar * kDecimal/*[]*/ = LPW(L"decimal");
static const UChar * kString/*[]*/ = LPW(L"string");
static const UChar * kBool/*[]*/ = LPW(L"boolean");
static const UChar * kArray/*[]*/ = LPW(L"array");
static const UChar * kMap/*[]*/ = LPW(L"map");
static const UChar * kPair/*[]*/ = LPW(L"pair");
static const UChar * kReference/*[]*/ = LPW(L"reference");
static const UChar * kCode/*[]*/ = LPW(L"tag");
static const UChar * kCustom/*[]*/ = LPW(L"custom");
static const UChar * kDBInput/*[]*/ = LPW(L"dbinput");
static const UChar * kDBOutput/*[]*/ = LPW(L"dboutput");

static const UChar * kBytesTypeName = LPW(L"bytes");

// base type function names
static const char * kDefault/*[]*/ = "default";

// special tags for custom types
static const char * kOnCompare/*[]*/ = "oncompare";
static const char * kOnAssign/*[]*/ = "onassign";
static const char * kOnDestroy/*[]*/ = "ondestroy";
static const char * kOnCreate/*[]*/ = "oncreate";
static const char * kOnConvert/*[]*/ = "onconvert";

// variable name where a custom tag's parameters are stored
static const char * kTagParams/*[]*/ = "tag_params";

// checksum
static const char * kCheckSum/*[]*/ = "__checksum__";

// the name & id for the current site
static const char * kSiteID/*[]*/ = "__site_id__";
static const char * kSiteName/*[]*/ = "__site_name__";

static const char * kLoopCount/*[]*/ = "__loop_count__";
static const char * kRecordCount/*[]*/ = "__record_count__";
static const char * kRelatedCount/*[]*/ = "__related_count__";
static const char * kRepeatCount/*[]*/ = "__repeat_count__";
static const char * kValueCount/*[]*/ = "__value_count__";

//static const char * kParentBody/*[]*/ = "__parent_body__";
static const char * kNameEncodingType = "ISO8859-1";
static const char * kUTF8EncodingType = "UTF-8";

enum SortOrder { orderAscending, orderDescending, orderCustom = 4 };

// new operators for data sources that support them
enum
{
	kLassoGreaterThan = '>   ',
	kLassoGreaterThanEquals = '>=  ',
	kLassoEquals = '=   ',
	kLassoLessThan = '<   ',
	kLassoLessThanEquals = '<=  ',
	kLassoBeginsWith = 'bgwt',
	kLassoEndsWith = 'ends',
	kLassoContains = 'cont',
	kLassoNotContains = '!cts',
	kLassoNotBeginsWith = '!bgs',
	kLassoNotEndsWith = '!end',
	kLassoAND = 'AND ',
	kLassoOR = 'OR  ',
	kLassoNOT = 'NOT ',
	kLassoNo = 'no  ',
	kLassoAny = 'any ',
	kLassoInList = ' nlt',
	kLassoNotInList = '!nlt',
	kLassoInFullText = ' ftx',
	kLassoInRegExp = ' rxp',
	kLassoNotInRegExp = '!rxp'
};

typedef enum lpEncodingType 
{ 
	encodeURL,							// TODO: Comment encoding methods here
	encodeRaw, 							// 
	encodeSmart, 						// 
	encodeBreak, 						// 
	encodeDefault, 						// 
	encodeStrictURL, 					// 
	encodeXML,
	encodeNone							// 
} encodingMethod;	// end encodingMethod

#endif
