#ifndef _LASSOPROTOUTILS_H_
#define _LASSOPROTOUTILS_H_

#include "LassoProto.h"

#if __cplusplus
extern "C" {
#endif

/* TO host endian */
void convert_endian_h( LPCommandBlock * block );
/* TO network endian */
void convert_endian_n( LPCommandBlock * block );

/* The data buffer is allocated using malloc and should be free'd by the caller */
typedef enum READ_RESULT
{
	READ_TIMEOUT,
	READ_OK,
	READ_ERROR
} READ_RESULT;

READ_RESULT read_block( int sock, LPCommandBlock* block, char** data, unsigned int* time_out );
int send_block( int sock, const LPCommandBlock* block, const char * data );

int log_message(int sock, const char * msg);

#if __cplusplus
}
#endif

#endif