//
//  RequestParams.h
//

#ifndef _REQUESTPARAMS_H_
#define _REQUESTPARAMS_H_

#ifdef __cplusplus
extern "C"
{
#endif

// Constants used for retrieving parameters from WebInputParams::GetNamedParam
// these are the same as the ones defined in WSAPI.h

typedef enum 
{
	rpPathArgKeyword		= '----',
	rpSearchArgKeyword		= 'kfor',
	rpUserKeyword			= 'user',
	rpPasswordKeyword		= 'pass',
	rpFromUser				= 'frmu',
	rpAddressKeyword		= 'addr',
	rpPostKeyword			= 'post',
	rpMethodKeyword			= 'meth',
	rpServerName			= 'svnm',
	rpServerPort			= 'svpt',
	rpScriptName			= 'scnm',
	rpFileName				= rpScriptName,
	rpLassoName				= rpScriptName,
	rpContentType			= 'ctyp',
	rpContentLength			= 'CLen',
	rpReferrerKeyword		= 'refr',
	rpRefererKeyword		= rpReferrerKeyword,		// old (incorrect) spelling kept around for compatibility
	rpUserAgentKeyword		= 'Agnt',
	rpActionKeyword			= 'Kact',
	rpActionPathKeyword		= 'Kapt',
	rpClientIPAddress		= 'Kcip',
	rpFullRequestKeyword	= 'Kfrq',
	rpRealmsKeyword			= 'Prlm',
	rpCurrentRealmKeyword	= 'CRlm',
	
	rpCookiesKeyword		= 'koky',
	
	rpIndexFile				= 'Pixf',

	rpSessionRootPath		= 'SPth',
	rpSessionErrorFile		= 'Perf',
	rpSessionNoAccessFile	= 'Pnaf',
	rpSessionLogFile		= 'Plgf',

	rpSessionSiteName		= 'Site',

	rpResolveFilePath		= 'RsFP',

	rpWebFileData			= 'RmFl', 	// return the file data from the session root
	rpRootFileData			= 'RmRF',	// return the file data from the root of the system

	rpGetUseLocalFiles		= 'GLoc',
	rpSetUseLocalFiles		= 'SLoc',

	rpGetDocRoot			= 'GDoc',
	rpSetDocRoot			= 'SDoc'

} RequestParamKeyword;

// these constants are used to retrieve params from Lasso::GetNamedParam
typedef enum 
{
	lpModulesFolderPath			= 'MPth',
	lpStartupItemsFolderPath	= 'SPth',
	lpLassoDataFilePath			= 'LDFP',
	lpLassoErrorsFilePath		= 'LEFP',
	lpDataRootFolderPath		= 'DRFP',

	lpStorageHost				= 'SHst',

	// relative path to scripts root
	lpScriptsRoot				= 'SRot',
	// relative path to site scripts root (most likely includes lpScriptsRoot)
	lpScriptsSiteRoot			= 'SSit'

} LassoParamKeyword;

#ifdef __cplusplus
}
#endif

#endif
