<?LassoScript

//
// Variables
//

_admin_addvar: 'build_connectorid', -default='1', -session='_admin', -override=(action_param: 'build_connectorid');
_admin_addvar: 'build_hostid', -session='_admin', -override=(action_param: 'build_hostid');
_admin_addvar: 'build_databaseid', -session='_admin', -override=(action_param: 'build_databaseid');
_admin_addvar: 'build_tableid', -session='_admin', -override=(action_param: 'build_tableid');
_admin_addvar: 'build_fieldid', -session='_admin', -override=(action_param: 'build_fieldid');

_admin_addvar: 'build_action', -default='None', -override=(action_param: 'build_action', (action_param: 'build_action', -count));
_admin_addvar: 'build_field_skip', -default=1, -session='_admin', -override=(action_param: 'build_field_skip');
_admin_addvar: 'build_navigation', -override=(action_param: 'build_navigation');
_admin_addvar: 'build_jump', -override=(action_param: 'build_jump');

_admin_addvar: 'database_name', -override=(action_param: 'database_name');
_admin_addvar: 'database_alias', -override=(action_param: 'database_alias');

_admin_addvar: 'table_name', -override=(action_param: 'table_name');
_admin_addvar: 'table_alias', -override=(action_param: 'table_alias');

_admin_addvar: 'field_id', -override=(action_param: 'field_id');
_admin_addvar: 'field_name', -override=(action_param: 'field_name');
_admin_addvar: 'field_orig', -override=(action_param: 'field_orig');
_admin_addvar: 'field_type', -override=(action_param: 'field_type');
_admin_addvar: 'field_enabled', -override=(action_param: 'field_enabled');
_admin_addvar: 'field_datasize', -override=(action_param: 'field_datasize', (action_param: 'field_datasize', -count));
_admin_addvar: 'field_precision', -override=(action_param: 'field_precision', (action_param: 'field_precision', -count));
_admin_addvar: 'field_casesensitive', -override=(action_param: 'field_casesensitive', (action_param: 'field_casesensitive', -count));
_admin_addvar: 'field_unsigned', -override=(action_param: 'field_unsigned', (action_param: 'field_unsigned', -count));
_admin_addvar: 'field_values', -override=(action_param: 'field_values', (action_param: 'field_values', -count));
_admin_addvar: 'field_allownull', -override=(action_param: 'field_allownull', (action_param: 'field_allownull', -count));
_admin_addvar: 'field_autoenter', -force=(action_param: 'field_autoenter');
_admin_addvar: 'field_index', -override=(action_param: 'field_index');
_admin_addvar: 'field_indextype', -override=(action_param: 'field_indextype');
_admin_addvar: 'field_indexprefix', -override=(action_param: 'field_indexprefix');
_admin_addvar: 'field_position', -override=(action_param: 'field_position');

_admin_addvar: 'create_action', -default='None', -override=(action_param: 'create_action');
_admin_addvar: 'field_action', -default='None', -override=(action_param: 'field_action');
_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

var: 'reserved_words' = (array:
	'add','all','alter','analyze','and','as','asc','auto_increment','bdb',
	'berkeleydb','between','bigint','binary','blob','both','by','cascade',
	'case','change','char','character','column','columns','constraint',
	'create','cross','current_date','current_time','current_timestamp',
	'database','databases','day_hour','day_minute','day_second','dec',
	'decimal','default','delayed','delete','desc','describe','distinct',
	'distinctrow','double','drop','else','enclosed','escaped','exists',
	'explain','fields','float','for','foreign','from','fulltext','function',
	'grant','group','having','high_priority','hour_minute','hour_second',
	'if','ignore','in','index','infile','inner','innodb','insert','int',
	'integer','interval','into','is','join','key','keys','kill','leading',
	'left','like','limit','lines','load','lock','long','longblob','longtext',
	'low_priority','master_server_id','match','mediumblob','mediumint',
	'mediumtext','middleint','minute_second','mrg_myisam','natural','not',
	'null','numeric','on','optimize','option','optionally','or','order',
	'outer','outfile','partial','precision','primary','privileges',
	'procedure','purge','read','real','references','regexp','rename',
	'replace','require','restrict','returns','revoke','right','rlike',
	'select','set','show','smallint','soname','sql_big_result',
	'sql_calc_found_rows','sql_small_result','ssl','starting','straight_join',
	'striped','table','tables','terminated','then','tinyblob','tinyint',
	'tinytext','to','trailing','union','unique','unlock','unsigned','update',
	'usage','use','user_resources','using','values','varbinary','varchar',
	'varying','when','where','with','write','xor','year_month','zerofill');


//
// Process Field Parameters
//

if: ( ($field_action >> 'Silent') && !($build_action >> 'Create')) || ($create_action >> 'Silent');

	// Create common SQL definition for field here
	var: 'field_sql' = '`' + $field_name + '` ' + $field_type;

	if: ($field_type >> 'INT');
		if: ($field_datasize != '');
			$field_sql += '(' + (integer: $field_datasize) + ')';
		/if;
	else: ($field_type >> 'DECIMAL');
		if: $field_datasize == '';
			var: 'field_datasize' = 14;
		/if;
		if: $field_precision == '';
			var: 'field_precision' = 2;
		/if;
		$field_sql += '(' + (integer: $field_datasize) + ',' + (integer: $field_precision) + ')';
	else: ($field_type >> 'DOUBLE') || ($field_type >> 'FLOAT');
		if: ($field_datasize != '') && ($field_precision != '');
			$field_sql += '(' + (integer: $field_datasize) + ',' + (integer: $field_precision) + ')';
		/if;
	else: ($field_type >> 'CHAR');
		if: $field_datasize == '';
			var: 'field_datasize' = 255;
		/if;
		$field_sql += '(' + (integer: $field_datasize) + ')';
	else: ($field_type >> 'SET') || ($field_type >> 'ENUM');
		if: $field_values == '';
			var: 'field_values' = '\'Value One\', \'Value Two\'';
		/if;
		$field_sql += '(' + $field_values + ')';
	/if;

	if: $field_type >> 'INT';
		if: $field_unsigned == 'Yes';
			$field_sql += ' UNSIGNED';
		/if;
	else: $field_type >> 'CHAR';
		if: $field_casesensitive == 'Yes';
			$field_sql += ' BINARY';
		/if;
	/if;

	if: $field_allownull == 'No';
		$field_sql += ' NOT NULL';
	/if;

	if: $field_autoenter != '';
		$field_sql += ' DEFAULT \'' + $field_autoenter + '\'';
	/if;

	if: ($field_position == 'FIRST') || ($field_position >> 'AFTER');
		$field_sql += ' ' + $field_position;
	/if;

	if: ($field_index >> 'Yes');

		if: $field_indexprefix != '';
			var: 'index_column' = $field_name + '(' + $field_indexprefix + ')';
		else;
			var: 'index_column' = $field_name;
		/if;

		if: $field_indextype >> 'index';
			$field_sql += ', ADD INDEX (' + $index_column + ')';
		else: $field_indextype >> 'unique';
			$field_sql += ', ADD INDEX (' + $index_column + ')';
		else: $field_indextype >> 'fulltext';
			$field_sql += ', ADD FULLTEXT (' + $index_column + ')';
		/if;
	/if;

	var: 'build_fielddetail'=(map);
	$build_fielddetail->(insert: 'id'=$field_id);
	$build_fielddetail->(insert: 'name'=$field_name);
	$build_fielddetail->(insert: 'type'=$field_type);
	$build_fielddetail->(insert: 'enabled'=$field_enabled);
	if: $field_enabled == 'Y';
		$build_fielddetail->(insert: 'status'='Enabled');
	else;
		$build_fielddetail->(insert: 'status'='Disabled');
	/if;
	$build_fielddetail->(insert: 'datasize'=$field_datasize);
	$build_fielddetail->(insert: 'precision'=$field_precision);
	$build_fielddetail->(insert: 'casesensitive'=$field_casesensitive);
	$build_fielddetail->(insert: 'unsigned'=$field_unsigned);
	$build_fielddetail->(insert: 'values'=$field_values);
	$build_fielddetail->(insert: 'allownull'=$field_allownull);
	$build_fielddetail->(insert: 'autoenter'=$field_autoenter);
	$build_fielddetail->(insert: 'index'=$field_index);
	$build_fielddetail->(insert: 'indextype'=$field_indextype);
	$build_fielddetail->(insert: 'indexprefix'=$field_indexprefix);

/if;


//
// Process Action
//


if: ($build_action >> 'Create') && !(var_defined: 'build_fielddetail');

	// Create template for new field

	var: 'build_fielddetail'=(map);
	$build_fielddetail->(insert: 'id'=0);
	$build_fielddetail->(insert: 'name'='New_Field');
	$build_fielddetail->(insert: 'type'='VARCHAR');
	$build_fielddetail->(insert: 'casesensitive'='No');
	$build_fielddetail->(insert: 'allownull'='No');
	$build_fielddetail->(insert: 'datasize'='255');
	$build_fielddetail->(insert: 'enabled'='Y');
	$build_fielddetail->(insert: 'status'='Enabled');
	$build_fielddetail->(insert: 'values'='\'Value One\',\'Value Two\'');

else: $field_action >> 'Update';

	if: ((var: 'field_name') == '');
		var: 'build_error'='Please specify a field name.';
	else: ($reserved_words >> (var: 'field_name'));
		var: 'build_error'='That field name is reserved in MySQL.  Please choose another.';
	else: (string_replaceregexp: (var: 'field_name'), -find='\\w|\\$', -replace='') != '';
		var: 'build_error'='Field names should consist of only letters, numbers, and the underscore character.';
	/if;

	if: !(var_defined: 'build_error');
		// Generate SQL to update field definition
	
		var:'sql' = 'ALTER TABLE `' + $database_name + '`.`' + $table_name + '` CHANGE COLUMN';
		$sql += ' `' + $field_orig + '` ';
		$sql += $field_sql;
	
		inline: -database=$database_alias, -sql=$sql;
			if: (error_currenterror) != (error_noerror);
				var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
			else;
				var: 'build_message' = 'The field was updated successfully.';
			/if;
		/inline;
	/if;

	if: !(var_defined: 'build_error');
		_admin_updatefield: $build_fieldid, 'name'=$field_name, 'enabled'=$field_enabled;
		if: $_code != (error_noerror);
			var: 'build_error' = $_error + ' (' + $_code + ')';
		else;
			var: 'build_message' = 'The field was updated successfully.';
		/if;
	/if;

	var: 'build_action' = 'Refresh Detail';

else: $dialog_action >> 'Delete';

	// Generate SQL to delete field definition

	var:'sql' = 'ALTER TABLE `' + $database_name + '`.`' + $table_name + '` DROP COLUMN';
	$sql += ' `' + $field_orig + '` ';

	inline: -database=$database_alias, -sql=$sql;
		if: (error_currenterror) != (error_noerror);
			var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
		else;
			var: 'build_message' = 'The field was updated successfully.';
		/if;
	/inline;

	_admin_deletefield: $build_fieldid;

	var: 'build_fielddetail' = null;
	var: 'build_action' = 'Refresh';

else: $create_action >> 'Create';

	var: 'build_navigation' = 'last';

	if: ((var: 'field_name') == '');
		var: 'build_error'='Please specify a field name.';
	else: ($reserved_words >> (var: 'field_name'));
		var: 'build_error'='That field name is reserved in MySQL.  Please choose another.';
	else: (string_replaceregexp: (var: 'field_name'), -find='\\w|\\$', -replace='') != '';
		var: 'build_error'='Field names should consist of only letters, numbers, and the underscore character.';
	/if;

	if: ((var: 'build_error') == '');

		// Generate SQL to create field

		var:'sql' = 'ALTER TABLE `' + $database_name + '`.`' + $table_name + '` ADD COLUMN ' + $field_sql;

		inline: -database=$database_alias, -sql=$sql;
			if: (error_currenterror) != (error_noerror);
				var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
			else;
				var: 'build_message' = 'The field was updated successfully.';
			/if;
		/inline;

	/if;

	if: ((var: 'build_error') == '');

		//	_admin_refreshsecurity;
		var: '__admin_fields_array' = null;
		_admin_refreshconnector: $build_connectorid;

		var: 'temp_fieldmap' = (_admin_listfields: $build_tableid);
		var: 'build_fieldid' = 0;

		loop: $temp_fieldmap->size;
			var: 'temp'=$temp_fieldmap->(get: loop_count)->second;
			if: $temp->(find: 'name') == $field_name;
				var: 'build_fieldid' = $temp->(find: 'id');
			/if;
		/loop;

		_admin_updatefield: $build_fieldid, 'enabled'=$field_enabled;

		var: 'build_action' = 'Refresh Detail';

	/if;

/if;


//
// Build Menus
//


var: 'build_connectormap' = (array);
var: 'build_hostmap' = (array);
var: 'build_databasemap' = (array);
var: 'build_tablemap' = (array);
var: 'build_fieldmap' = (array);

if: ($build_action >> 'Refresh');
	_admin_refreshsecurity;
/if;

var: 'temp_connectormap' = (_admin_listconnectors);
var: 'build_connectormap' = (array);
loop: $temp_connectormap->size;
	var: 'temp'=$temp_connectormap->(get:loop_count)->second;
	var: 'id'=$temp_connectormap->(get:loop_count)->first;
	if: ($temp->(find: 'name') >> 'MySQL') && ($temp->(find: 'status') == 'enabled');
		$build_connectormap->(insert: $id = $temp);
	/if;
/loop;
var: 'temp' = (_admin_defaultconnector: -id=$build_connectorid, $build_connectormap);
if: ($temp != null);
	var: 'build_connectorid' = $temp->first;
	var: 'build_connectordetail' = $temp->second;
	var: 'build_connectoralias' = $build_connectordetail->(find: 'alias');
else;
	var: 'build_connectorid' = 0;
	var: 'build_connectordetail' = null;
/if;

if: ($build_action >> 'Refresh') && ($build_connectorid != 0);
	_admin_refreshconnector: $build_connectorid;
/if;

if: ($build_connectorid > 0);
	var: 'build_hostmap' = (_admin_listhosts: $build_connectorid);
	loop: -loopfrom=$build_hostmap->size, -loopto=1, -loopincrement=(-1);
		if: $build_hostmap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$build_hostmap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaulthost: $build_hostid, $build_hostmap);
	if: ($temp != null);
		var: 'build_hostid' = $temp->first;
		var: 'build_hostdetail' = $temp->second;
	else;
		var: 'build_hostid' = 0;
		var: 'build_hostdetail' = null;
	/if;
else;
	var: 'build_hostid' = 0;
	var: 'build_hostdetail' = null;
/if;

if: ($build_hostid > 0);
	var: 'build_databasemap' = (_admin_listdatabases: $build_hostid);
	loop: -loopfrom=$build_databasemap->size, -loopto=1, -loopincrement=(-1);
		if: $build_databasemap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$build_databasemap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaultdatabase: $build_databaseid, $build_databasemap);
	if: ($temp != null);
		var: 'build_databaseid' = $temp->first;
		var: 'build_databasedetail' = $temp->second;
		var: 'build_databasename' = $build_databasedetail->(find: 'name');
		var: 'build_databasealias' = $build_databasedetail->(find: 'alias');
	else;
		var: 'build_databaseid' = 0;
		var: 'build_databasedetail' = null;
	/if;
else;
	var: 'build_databaseid' = 0;
	var: 'build_databasedetail' = null;
/if;

if: ($build_databaseid > 0);
	var: 'build_tablemap' = (_admin_listtables: $build_databaseid);
	loop: -loopfrom=$build_tablemap->size, -loopto=1, -loopincrement=(-1);
		if: $build_tablemap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$build_tablemap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaulttable: $build_tableid, $build_tablemap);
	if: ($temp != null);
		var: 'build_tableid' = $temp->first;
		var: 'build_tabledetail' = $temp->second;
		var: 'build_tablename' = $build_tabledetail->(find: 'name');
		var: 'build_tablealias' = $build_tabledetail->(find: 'alias');
	else;
		var: 'build_tableid' = 0;
		var: 'build_tabledetail' = null;
	/if;
else;
	var: 'build_tableid' = 0;
	var: 'build_tabledetail' = null;
/if;

if: ($build_tableid > 0) && ($build_tabledetail->(find: 'status') == 'enabled');
	var: 'build_fieldmap' = (_admin_listfields: $build_tableid);
	var: 'temp' = (_admin_defaultfield: $build_fieldid, $build_fieldmap);
	if: ($temp != null);
		var: 'build_fieldid' = $temp->first;
//		var: 'build_fielddetail' = $temp->second;
//		var: 'build_fieldname' = $build_fielddetail->(find: 'name');
//		var: 'build_fieldalias' = $build_fielddetail->(find: 'alias');
	else;
		var: 'build_fieldid' = 0;
		var: 'build_fielddetail' = null;
	/if;
else;
	var: 'build_fieldid' = 0;
	var: 'build_fielddetail' = null;
/if;


//
// Correct name of 'site' database
//

if: ($build_connectorid == 1) && ($build_databasename == 'site');
	var: 'build_databasename' = 'lasso_site_1';
/if;


//
// Add Field Types
//

if: (var:'build_databasealias') && (var:'build_databasename') && (var:'build_tablename');

	// Re-order the fields in the order they exist in the actual database
	var: 'build_fieldorder' = (array);

	inline: -database=$build_databasealias, -maxrecords='all', -sql='DESCRIBE `' + $build_databasename + '`.`' + $build_tablename + '`';
		records;
			var: 'rawtype' = (field: 'type');
			var: 'type' = $rawtype;
			var: 'param' = '';
			var: 'precision' = '';

			if: ($rawtype >> '(');
				var: 'param' = (string_replaceregexp: $rawtype, -find='([^(]+)\\(([^)]+)\\).*', -replace='\\2');
				var: 'type'  = (string_replaceregexp: $rawtype, -find='([^(]+)\\(([^)]+)\\).*', -replace='\\1');
			else: ($rawtype >> ' ');
				var: 'type'  = (string_replaceregexp: $rawtype, -find='([^ ]+) .*', -replace='\\1');
			/if;

			if: ($type >> 'FLOAT') || ($type >> 'DECIMAL') || ($type >> 'DOUBLE');
				if: $param >> ',';
					var: 'precision' = (string_replaceregexp: $param, -find='([^,]+),(.+)', -replace='\\2');
					var: 'param'  = (string_replaceregexp: $param, -find='([^,]+),(.+)', -replace='\\1');
				/if;
			/if;

			loop: $build_fieldmap->size;
				var: 'id' = $build_fieldmap->(get:loop_count)->first;
				var: 'temp' = $build_fieldmap->(get:loop_count)->second;
				if: ($temp != null) && ($temp->(find: 'name') == (field: 'field'));
					$temp->(insert: 'rawtype'=$rawtype);
					$temp->(insert: 'type'= (string_uppercase: $type));
					$temp->(insert: 'param'= $param);
					$temp->(insert: 'precision'= $precision);
					$temp->(insert: 'autoenter'= (field: 'default'));
					if: (field: 'null') == 'YES';
						$temp->(insert: 'allownull'='Yes');
					else;
						$temp->(insert: 'allownull'='No');
					/if;
					if: $rawtype >> 'BINARY';
						$temp->(insert: 'casesensitive'='Yes');
					else;
						$temp->(insert: 'casesensitive'='No');
					/if;
					if: $rawtype >> 'UNSIGNED';
						$temp->(insert: 'unsigned'='Yes');
					/if;
					$build_fieldorder->(insert: (pair: $id=$temp));
					loop_abort;
				/if;
			/loop;

		/records;
	/inline;

	var: 'build_fieldmap' = $build_fieldorder;
/if;


if: (!var_defined: 'build_fielddetail');
	var: 'build_fielddetail' = $build_fieldmap->(find: $build_fieldid)->(get:1)->second;
/if;


//
// Process Navigation
//

if: $build_navigation >> 'Prev';
	$build_field_skip -= 10;
else: $build_navigation >> 'Next';
	$build_field_skip += 10;
else: $build_navigation >> 'First';
	$build_field_skip = 1;
else: $build_navigation >> 'Last';
	$build_field_skip = $build_fieldmap->size - (($build_fieldmap->size - 1) % 10);
else: $build_navigation >> 'Jump';
	$build_field_skip = integer: $build_jump;
/if;

var: 'found_count' = $build_fieldmap->size;
var: 'build_field_skip' = integer: (math_max: 1, (math_min: $build_field_skip, $found_count));
var: 'shown_first' = $build_field_skip;
var: 'shown_last' = integer: (math_min: $found_count, $build_field_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

//
// Constants
//


var:'build_datatypemap' = (array:
	'TINYINT'=(map:
		'type'='TINYINT',
		'name'='Integer 8 Bit',
		'option'='Unsigned'
	),
	'SMALLINT'=(map:
		'type'='SMALLINT',
		'name'='Integer 16 Bit',
		'option'='Unsigned'
	),
	'MEDIUMINT'=(map:
		'type'='MEDIUMINT',
		'name'='Integer 24 Bit',
		'option'='Unsigned'
	),
	'INT'=(map:
		'type'='INT',
		'name'='Integer 32 Bit',
		'option'='Unsigned'
	),
	'BIGINT'=(map:
		'type'='BIGINT',
		'name'='Integer 64 Bit',
		'option'='Unsigned'
	),
	'FLOAT'=(map:
		'type'='FLOAT',
		'name'='Decimal 32 Bit'
	),
	'DOUBLE'=(map:
		'type'='DOUBLE',
		'name'='Decimal 64 Bit'
	),
	'DECIMAL'=(map:
		'type'='DECIMAL',
		'name'='Fixed Decimal'
	),
	'CHAR'=(map:
		'type'='CHAR',
		'name'='String Fixed Max 255 Chars',
		'option'='Size,Binary'
	),
	'VARCHAR'=(map:
		'type'='VARCHAR',
		'name'='String Max 255 Chars',
		'option'='Size,Binary'
	),
	'DATE'=(map:
		'type'='DATE',
		'name'='%Y-%m-%d'
	),
	'TIME'=(map:
		'type'='TIME',
		'name'='%H:%M:%S'
	),
	'DATETIME'=(map:
		'type'='DATETIME',
		'name'='%Y-%m-%d %H:%M:%S'
	),
	'TIMESTAMP'=(map:
		'type'='TIMESTAMP',
		'name'='Auto-Enter'
	),
	'ENUM'=(map:
		'type'='ENUM',
		'name'='Value From List'
	),
	'SET'=(map:
		'type'='SET',
		'name'='Values From List'
	),
	'TINYTEXT'=(map:
		'type'='TINYTEXT',
		'name'='String 255 Chars'
	),
	'TEXT'=(map:
		'type'='TEXT',
		'name'='String 64K Chars'
	),
	'MEDIUMTEXT'=(map:
		'type'='MEDIUMTEXT',
		'name'='String 16M Chars'
	),
	'LONGTEXT'=(map:
		'type'='LONGTEXT',
		'name'='String 4GB Chars'
	),
	'TINYBLOB'=(map:
		'type'='TINYBLOB',
		'name'='Binary Data 255 Bytes'
	),
	'BLOB'=(map:
		'type'='BLOB',
		'name'='Binary Data 64K Bytes'
	),
	'MEDIUMBLOB'=(map:
		'type'='MEDIUMBLOB',
		'name'='Binary Data 16M Bytes'
	),
	'LONGBLOB'=(map:
		'type'='LONGBLOB',
		'name'='Binary Data 4GB Bytes'
	)
);

?>