<?LassoScript
// This file sets up the environment in which the page will run.

var: 'lassoapp_root'=(action_param:'lassoapp_root');
var: 'lassoapp_name'=(action_param:'lassoapp_root');
var: 'lassoapp_entry'=(action_param:'lassoapp_entry');
var: 'lassoapp_result'=(action_param: 'lassoapp_result');
var: 'lassoapp_action'=(action_param: 'lassoapp_action');

if: (var: 'lassoapp_entry') == '';
	var: 'lassoapp_entry'='default' + '.' + 'lasso';  // Workaround for LassoApp issue
/if;

if: (lasso_version: -lassoplatform) >> 'Win32';
	var: 'windows_local'=':\\\\Program Files\\Blue World Communications\\Lasso Professional 7\\Admin\\BuildLassoApps\\';
	var: 'windows_lassoapp'='://Program Files/Blue World Communications/Lasso Professional 7/Admin/BuildLassoApps/';
	var: 'local_folder'='';
	var: 'lassoapp_folder'='./Admin/BuildLassoApps/';

	var: 'drive_letters'='CDEFGHIJKLMNOPQR';
	loop: ($drive_letters->length);
		var: 'temp'=$drive_letters->(get: loop_count) + $windows_lassoapp;
		if: (file_exists: $temp);
			var: 'local_folder'=$drive_letters->(get: loop_count) + $windows_local;
			var: 'lassoapp_folder'=$drive_letters->(get: loop_count) + $windows_lassoapp;
		/if;
	/loop;
else: (lasso_version: -lassoplatform) >> 'Linux';
	var: 'lassoapp_folder'='///usr/local/Lasso Professional 7/Admin/BuildLassoApps/';
	var: 'local_folder'='/usr/local/Lasso Professional 7/Admin/BuildLassoApps/';
	if: !(file_exists: $lassoapp_folder);
		var: 'local_folder'='';
	/if;
else;
	var: 'lassoapp_folder'='///Applications/Lasso Professional 7/Admin/BuildLassoApps/';
	var: 'local_folder'='/Applications/Lasso Professional 7/Admin/BuildLassoApps/';
	if: !(file_exists: $lassoapp_folder);
		var: 'local_folder'='';
	/if;
/if;

if: ($local_folder == '');
	var: 'lassoapp_success'='An unknown error occurred.';
	var: 'lassoapp_error'='BuildLassoApps folder not found.';
	var: 'lassoapp_action'='Error';
/if;

var: 'local_root' = $local_folder + $lassoapp_root;
var: 'local_result' = $local_root + '.LassoApp';
var: 'lassoapp_root' = $lassoapp_folder + $lassoapp_root;
var: 'lassoapp_result' = $lassoapp_root + '.LassoApp';

if: (var: 'lassoapp_action') >> 'Create';
	var: 'lassoapp_success'='An unknown error occurred.';

	if: (file_exists: $lassoapp_result);
		 var: 'lassoapp_backup'=$lassoapp_result;
		 $lassoapp_backup = (string_replace: $lassoapp_backup, -find='.LassoApp', -replace='2.LassoApp');
		 file_move: $lassoapp_result, $lassoapp_backup, -fileoverwrite;
	/if;

	// Call the LassoApp Create function with the appropriate arguments
	protect;
		var: 'lassoapp_error'=(LassoApp_Create: -root=$local_root, -entry=$lassoapp_entry, -result=$local_result);
	/protect;

	// Call the LassoApp Dump function to clear the old LassoApp from the cache.
	lassoapp_dump: $local_result;

	if: (file_exists: $lassoapp_result);
		var: 'lassoapp_success'='The LassoApp \"' + $lassoapp_name + '.LassoApp\" was created successfully.';
	/if;
/if;

// list directories
var: 'dirs' = (file_listdirectory:$lassoapp_folder);
loop: -loopfrom=$dirs->size, -loopto=1, -loopincrement=(-1);
	if: !$dirs->get:loop_count->endswith:'/';
		$dirs->remove:loop_count;
	/if;
/loop;

?>
