<?LassoScript

//log_setdestination: 0, 1, 0;
//log_setdestination: 1, 2, 0;
//log_setdestination: 2, 2, 1;

_admin_addvar: 'error_action', -default='None', -override=(action_param: 'error_action');
_admin_addvar: 'error_critical', -default='None', -override=(action_param: 'error_critical');
_admin_addvar: 'error_warning', -default='None', -override=(action_param: 'error_warning');
_admin_addvar: 'error_detail', -default='None', -override=(action_param: 'error_detail');

var: 'error_critical' = (string_replace: -find='\r', -replace=', ', $error_critical);
var: 'error_warning' = (string_replace: -find='\r', -replace=', ', $error_warning);
var: 'error_detail' = (string_replace: -find='\r', -replace=', ', $error_detail);

var: 'error_mapping' = (map:
	'critical'= log_level_critical,
	'warning' = log_level_warning,
	'detail' = log_level_detail,
	'file' = log_destination_file,
	'database' = log_destination_database,
	'console' = log_destination_console
);

if: $error_action >> 'Reset';
	var: 'error_critical' = 'database, console, file';
	var: 'error_warning' = 'console';
	var: 'error_detail' = 'console';
	var: 'error_action' = 'Update';
/if;

if: $error_action >> 'Update';

	var: 'level' = $error_mapping->(find: 'critical');
	var: 'file'=0, 'database'=0, 'console'=0;
	if: $error_critical >> 'file';
		var: 'file' = $error_mapping->(find: 'file');
	/if;
	if: $error_critical >> 'database';
		var: 'database' = $error_mapping->(find: 'database');
	/if;
	if: $error_critical >> 'console';
		var: 'console' = $error_mapping->(find: 'console');
	/if;
	log_setdestination: $level, $file, $database, $console;

	var: 'level' = $error_mapping->(find: 'warning');
	var: 'file'=0, 'database'=0, 'console'=0;
	if: $error_warning >> 'file';
		var: 'file' = $error_mapping->(find: 'file');
	/if;
	if: $error_warning >> 'database';
		var: 'database' = $error_mapping->(find: 'database');
	/if;
	if: $error_warning >> 'console';
		var: 'console' = $error_mapping->(find: 'console');
	/if;
	log_setdestination: $level, $file, $database, $console;

	var: 'level' = $error_mapping->(find: 'detail');
	var: 'file'=0, 'database'=0, 'console'=0;
	if: $error_detail >> 'file';
		var: 'file' = $error_mapping->(find: 'file');
	/if;
	if: $error_detail >> 'database';
		var: 'database' = $error_mapping->(find: 'database');
	/if;
	if: $error_detail >> 'console';
		var: 'console' = $error_mapping->(find: 'console');
	/if;
	log_setdestination: $level, $file, $database, $console;

	log_critical: 'Critical error messages are now being logged to ' + $error_critical + '.';
	log_warning: 'Warnings are now being logged to ' + $error_warning + '.';
	log_detail: 'Detailed status messages are now being logged to ' + $error_detail + '.';

/if;

var: 'error_critical' = '';
var: 'error_warning' = '';
var: 'error_detail' = '';

inline: -database=(_admin_internaldatabase), -table='global_prefs', -search, -op='bw', 'store_key'='log';
	records;
		var: 'key' = (integer: (field: 'data'));
		var: 'prefs' = '';
		if: $key->(bittest: 1);
			$prefs += 'console,';
		/if;
		if: $key->(bittest: 2);
			$prefs += 'file,';
		/if;
		if: $key->(bittest: 3);
			$prefs += 'database,';
		/if;

		$prefs->(removetrailing: ',');

		if: (field: 'store_key') == 'log_critical_dest';
			var: 'error_critical' = $prefs;
		else: (field: 'store_key') == 'log_detail_pref';
			var: 'error_detail' = $prefs;
		else: (field: 'store_key') == 'log_warning_dest';
			var: 'error_warning' = $prefs;
		/if;
	/records;
/inline;

?>
