<?LassoScript

//
// Variables
//

_admin_addvar: 'datasource_connectorid', -default='1', -session='_admin', -override=(action_param: 'datasource_connectorid');
_admin_addvar: 'datasource_hostid', -session='_admin', -override=(action_param: 'datasource_hostid');
_admin_addvar: 'datasource_databaseid', -session='_admin', -override=(action_param: 'datasource_databaseid');

_admin_addvar: 'datasource_action', -default='None', -override=(action_param: 'datasource_action', (action_param: 'datasource_action', -count));
_admin_addvar: 'datasource_actionraw', -default='None', -override=(action_param: 'datasource_action');
_admin_addvar: 'datasource_database_skip', -default=1, -session='_admin', -override=(action_param: 'datasource_database_skip');
_admin_addvar: 'datasource_navigation', -override=(action_param: 'datasource_navigation');
_admin_addvar: 'datasource_jump', -override=(action_param: 'datasource_jump');

_admin_addvar: 'database_name', -override=(action_param: 'database_name');
_admin_addvar: 'database_alias', -override=(action_param: 'database_alias');
_admin_addvar: 'database_enabled', -override=(action_param: 'database_enabled');
_admin_addvar: 'database_username', -force=(action_param: 'database_username');
_admin_addvar: 'database_password', -force=(action_param: 'database_password');
_admin_addvar: 'database_sqlstop', -force=(action_param: 'database_sqlstop');
_admin_addvar: 'database_usedefaults', -override=(action_param: 'database_usedefaults');
_admin_addvar: 'database_extra', -override=(action_param: 'database_extra');

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');


//
// Process Action
//

if: $datasource_action >> 'Update';

	_admin_updatedatabase: $datasource_databaseid,
		'alias'=$database_alias,
		'enabled'=$database_enabled,
		'username'=$database_username,
		'password'=$database_password,
		'sql_stop'=$database_sqlstop,
		'always_use_defaults'=$database_usedefaults,
		'extra'=$database_extra;

	if: $_code != (error_noerror);
		var: 'datasource_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'datasource_message' = 'The database was updated successfully.';
	/if;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);
	var: 'datasource_databasedetail' = $datasource_databasemap->(find: $datasource_databaseid)->(get:1)->second;
	var: 'datasource_databasename' = $datasource_databasedetail->(find: 'name');

	var: 'datasource_action' = 'Detail';

else: $dialog_action >> 'Delete Settings';

	iterate: $datasource_tablemap, (var: 'temp_table');
		var: 'temp_map' = (_admin_listfields: $temp_table->first);
		iterate: $temp_map, (var: 'temp_field');
			_admin_deletefield: $temp_field->first;
		/iterate;
		_admin_deletetable: $temp_table->first;
	/iterate;
	_admin_deletedatabase: $datasource_databaseid;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);
	var: 'datasource_databasedetail' = -1;
	var: 'datasource_databasename' = null;

else: $dialog_action >> 'Delete All Settings';

	iterate: $datasource_databasemap, (var: 'temp_database');
		var: 'temp_tables' = (_admin_listtables: $temp_database->first);
		iterate: $temp_tables, (var: 'temp_table');
			var: 'temp_map' = (_admin_listfields: $temp_table->first);
			iterate: $temp_map, (var: 'temp_field');
				_admin_deletefield: $temp_field->first;
			/iterate;
			_admin_deletetable: $temp_table->first;
		/iterate;
		_admin_deletedatabase: $temp_database->first;
	/iterate;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);
	var: 'datasource_databasedetail' = -1;
	var: 'datasource_databasename' = null;

else: $dialog_action >> 'Enable All New';

	iterate: $datasource_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		var: 'detail' = $temp_database->second;
		if: $detail->(find: 'status') == 'New';
			_admin_updatedatabase: $id, 'enabled'='Y', 'always_use_defaults'='Y';
		/if;
	/iterate;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);

else: $dialog_action >> 'Enable All';

	iterate: $datasource_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		_admin_updatedatabase: $id, 'enabled'='Y', 'always_use_defaults'='Y';
	/iterate;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);

else: $dialog_action >> 'Disable All';

	iterate: $datasource_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		_admin_updatedatabase: $id, 'enabled'='N';
	/iterate;

	var: '__admin_databases_array' = null;
	_admin_refreshconnector: $datasource_connectorid;

	var: 'datasource_databasemap' = (_admin_listdatabases: $datasource_hostid);

else: $datasource_action >> 'List Tables';

	// Redirect
	var: 'link' = $admin_link + '&tab3=tables' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_hostid=' + $datasource_hostid +
		'&datasource_databaseid=' + $datasource_databaseid;
	redirect_url: $link;
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;
	abort;

/if;


//
// Process Navigation
//

if: $datasource_navigation >> 'Prev';
	$datasource_database_skip -= 10;
else: $datasource_navigation >> 'Next';
	$datasource_database_skip += 10;
else: $datasource_navigation >> 'First';
	$datasource_database_skip = 1;
else: $datasource_navigation >> 'Last';
	$datasource_database_skip = $datasource_databasemap->size - (($datasource_databasemap->size - 1) % 10);
else: $datasource_navigation >> 'Jump';
	$datasource_database_skip = integer: $datasource_jump;
/if;

var: 'found_count' = $datasource_databasemap->size;
var: 'datasource_database_skip' = integer: (math_max: 1, (math_min: $datasource_database_skip, $found_count));
var: 'shown_first' = $datasource_database_skip;
var: 'shown_last' = integer: (math_min: $found_count, $datasource_database_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
