<?LassoScript

define_tag:'_table_backup';
	precondition: params->size && params->(get:1)->length;

	inline: -database=$db, -sql=
		'BACKUP TABLE ' + $db + '.' + (params->get:1) + ' TO "' + $tmp_dir + '"';
		if: (error_currenterror:-errorcode) || (field:'msg_text') != 'OK';
			$failed_backup->insert:(params->get:1);
			return: false;
		else;
			return: true;
		/if;
	/inline;
/define_tag;

define_tag:'_table_restore';
	precondition: params->size && params->(get:1)->length;

	inline: -database=$db, -sql='DROP TABLE ' + $db + '.' + (params->get:1); /inline;

	inline: -database=$db, -sql=
		'RESTORE TABLE ' + $db + '.' + (params->get:1) + ' FROM "' + $tmp_dir + '"';
		if: error_currenterror:-errorcode;
			$failed_restore->insert:(params->get:1);
		/if;
	/inline;
/define_tag;



// ------------
// const

var:'kImportPath' = 'Lasso3Export/';

var:'kTableNames' = (array:
	'security_datasource_hosts',
	'security_datasource_databases',
	'security_database_tables',
	'security_table_fields',
	'security_groups',
	'security_users',
	'security_ug_map',
	'security_group_db_map'
);

var:'kDsIDs' = (map:'FMRemoteDataSource'='-11','ODBCDS'='-12','4DDS'='-13','MySQLDS'='-14');

var:'kDbFileName' = (pair: 'security_datasource_databases'='securitydatasourcedatabases');


// ------------
// vars

var: 'err'=0, 'err_msg'='';
var: 'db'='lasso_internal';
var: 'temp'='';
var: 'backslash' = '\ '->get:1;

var: 'ds_names' = '';
var: 'ds_ids' = '';
var: 'criteria' = '';
var: 'elts' = '';

var: 'table_count' = 0;
var: 'table_name' = '';
var: 'tables_good' = array;
var: 'tables_failed' = array;
var: 'failed_backup'=array;
var: 'failed_restore'=array;

var: 'files' = array;
var: 'file_name' = '';
var: 'filepath'=array;

var: 'dirs' = array;
var: 'dir_name' = '';

var: 'tmp_dir'='';
var: 'base_dir' = '';
var: 'lasso_dir' = '';

var: 'failed_backup'=array;
var: 'failed_restore'=array;

var: 'error_array' = array;
var: 'action' = action_param:'action';

if: (action_param:'dialog_action') != null;
	$action = action_param:'dialog_action';
/if;

// -------------
// main

	// get temp and base dirs
	inline: -database=$db, -sql='SHOW VARIABLES LIKE "%dir"';
		records;
			if: (field:'variable_name') == 'basedir';
				$base_dir = (field:'value');
			else: (field:'variable_name') == 'tmpdir';
				$tmp_dir = (field:'value');
			/if;
		/records;
	/inline;

	// parse the filepath
	if: ($base_dir->(get:2) == ':') && ($base_dir->(get:3) == $backslash);	//win
		$filepath = $base_dir->split:$backslash;
		$filepath->(insert:'', 2);

		$tmp_dir = (string_replace:$tmp_dir,-find=$backslash, -replace='/');
		$tmp_dir = (string_insert:$tmp_dir, -text='/', -position=3);
	else;
		$filepath = $base_dir->(split:'/');								//unix
		$filepath->(insert:'/', 1);

		$tmp_dir = '//' + $tmp_dir;
	/if;

	$filepath->(insert:'Admin', ($filepath->size) - 1);
	$filepath->(insert:'Upgrade', ($filepath->size) - 1);
	$filepath->(remove: ($filepath->size) - 1);
//	($filepath->(get:($filepath->size) - 1)) = $dir_name;

	$lasso_dir = '';
	loop: $filepath->size;
		$lasso_dir += ($filepath->(get: loop_count) + '/');
	/loop;
	$lasso_dir = $lasso_dir->(substring: 0, ($lasso_dir->length - 1));

	database_tablenames: $db;
		if: ($kTableNames->find:database_tablenameitem)->size;
			$table_count += 1;
		/if;
	/database_tablenames;

// make sure L3Export/ directory exists
$dirs = file_listdirectory:($lasso_dir + $kImportPath);

loop: ($dirs->size);
	if: ($dirs->(get: loop_count) >> 'security_');
		$dir_name = 'Lasso3Import/';
	/if;
/loop;

if: $action >> 'Import';
	protect;

		fail_if: ($kTableNames->size != $table_count), 11, 'One or more security tables are missing.';

		fail_if: !$dir_name, 1, 'Upgrade settings folder not found. Make sure ' + $kImportPath + ' directory is present in the LP6 folder.';
		fail_if: (!$base_dir || !$tmp_dir), 2, 'Could not determine MySQL base or and/or temp directory';

		// list files
		$files = file_listdirectory:($lasso_dir + $kImportPath);

		// did we find any files?
		fail_if: !$files->size, 3, 'No settings were found';

		// first pass: make sure filenames match table names
		loop: $kTableNames->size;
			$table_name = $kTableNames->(get:loop_count);

			// handle special cases first
			if: $table_name == $kDbFileName->first;
				$file_name = ($kDbFileName->second) + '.txt';
			else;
				$file_name = $table_name + '.txt';
			/if;

			if:!($files->find:$file_name)->size;
				$error_array->insert:'File "' + $file_name + '" not found';
			/if;

		/loop;

		fail_if: ($error_array->size), 4, 'The following errors have occurred: ';

		// build the filepath
		$filepath = (list_tostring:'filepath', -listdelimiter='/') + '/';

		loop: $kTableNames->size;

			$table_name = $kTableNames->(get:loop_count);

			// table name
			if: $table_name == $kDbFileName->first;
				$file_name = ($kDbFileName->second) + '.txt';
			else;
				$file_name = $table_name + '.txt';
			/if;

			if: ($table_name == 'security_users')
			 || ($table_name == 'security_groups');
				// Don't delete Administrator or Anonymous users
				// or Administrators or Any Users groups.
				$criteria = ' where id not in (1,2)';
			else: ($table_name == 'security_ug_map');
				// Don't delete mappings between default users and groups.
				$criteria = ' where (id_user not in (1,2)) and (id_group not in (1,2))';
			else: ($table_name == 'security_datasource_hosts');
				// Don't delete Lasso MySQL host.
				$criteria = ' where (id not in (1)) and (id_datasource not in (1))';
			else: ($table_name == 'security_datasource_databases');
				// Don't delete Lasso MySQL databases.
				$criteria = ' where (id_datasource not in (-1,1)) and (id_host not in (-1,1))';
			else: ($table_name == 'security_database_tables');
				// Don't delete tables in Lasso MySQL databases.
				var: 'temp_list'='';
				inline: -search,
				    -database='lasso_internal',
				    -table='security_datasource_databases',
				    -oplogical='or',
				    'id_datasource'=1,
				    'id_datasource'=-1,
				    -maxrecords='all';
					records;
						var: 'temp_list' = $temp_list + ',' + (field: 'id');
					/records;
				/inline;

				$temp_list->(removeleading:',');
				if: ($temp_list) != '';
					$criteria = ' where (id_database not in (' + $temp_list + '))';
				else;
					$criteria = '';
				/if;
			else: ($table_name == 'security_table_fields');
				$criteria = '';
			else;
				$criteria = '';
			/if;

			// proceed only after successful backup
			fail_if: !(_table_backup: $table_name), 5, 'Failed to back up table "' + $table_name + '"';

			inline: -database=$db, -sql='DELETE FROM ' + $db + '.' + $table_name + $criteria;
				fail_if: (error_currenterror:-errorcode), 6, 'Error deleting records from ' + $table_name;

				inline: -database=$db, -sql='LOAD DATA INFILE "' + $filepath + $kImportPath + $file_name +
						'" INTO TABLE ' + $db + '.' + $table_name + ' LINES TERMINATED BY \'\r\n\' IGNORE 1 LINES';

					if: !error_currenterror:-errorcode;
						$tables_good->insert:$table_name;
					else;
						// import failed, restore the table
						_table_restore: $table_name;
						fail: 7, 'Failed to import file "' + $file_name + '" (' + (error_currenterror:-errorcode) + ')';
					/if;
				/inline;
			/inline;

		/loop;

		// look up and replace datasource ids
		loop: $kDsIDs->size;
			$ds_names += '\'' + ($kDsIDs->(get:loop_count)->first) + '\',';
			$ds_ids += '' + ($kDsIDs->(get:loop_count)->second) + ',';
		/loop;

		if: $ds_names && $ds_ids;

			$criteria = '';
			$ds_names->removetrailing:',';
			$ds_ids->removetrailing:',';

			inline: -database=$db, -maxrecords='all', -sql='SELECT id, name FROM ' + $db + '.security_datasources where name in (' + $ds_names + ')';
				fail_if: !found_count, 12, 'Error looking up datasource ids (' + (error_currenterror:-errorcode) + ')';
				records;
					$elts += '\'' + (field:'id') + '\',';
					$criteria += '\'' + ($kDsIDs->find:field:'name') + '\',';
				/records;
				$criteria->removetrailing:',';
				$elts->removetrailing:',';
			/inline;

			fail_if: (!$criteria || !$elts), 13, 'Error looking up datasource id update query (' + (error_currenterror:-errorcode) + ')';

			// update databases
			inline: -database=$db, -maxrecords='all', -sql='UPDATE ' + $db +
				'.security_datasource_databases set id_datasource=ELT(FIELD(id_datasource,' + $criteria + '), '
					+ $elts + ') where id_datasource in (' + $ds_ids + ')';
				fail_if: (error_currenterror:-errorcode),
					14, 'Error updating look-up datasource ids in databases security table (' + (error_currenterror:-errorcode) + ')';
			/inline;

			// update hosts
			inline: -database=$db, -maxrecords='all', -sql='UPDATE ' + $db +
				'.security_datasource_hosts set id_datasource=ELT(FIELD(id_datasource,' + $criteria + '), '
					+ $elts + ') where id_datasource in (' + $ds_ids + ')';
				fail_if: (error_currenterror:-errorcode),
					13, 'Error updating look-up datasource ids in hosts security table (' + (error_currenterror:-errorcode) + ')';
			/inline;

		/if;

		// reload datasources
		inline: -database=$db, -maxrecords='all', -sql='SELECT id FROM ' + $db + '.security_datasources';
			if: !(error_currenterror:-errorcode);
				records;
					_datasource_reload:integer:field:'id';
				/records;
			/if;
		/inline;

		// lasso_internal
		_datasource_reload:'InternalMySQLDS';

		// reload cache
		_admin_refreshsecurity;

		// catch
		handle: (error_currenterror:-errorcode) != 0;
			$err = error_currenterror:-errorcode; $err_msg = error_currenterror;

			// revert all tables
			loop: $tables_good->size;
				_table_restore: ($tables_good->get:loop_count);
			/loop;
		/handle;
	/protect;
/if;
?>
