<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));

_admin_addvar: 'file_create', -override=(action_param: 'file_create');
_admin_addvar: 'file_read', -override=(action_param: 'file_read');
_admin_addvar: 'file_write', -override=(action_param: 'file_write');
_admin_addvar: 'file_move', -override=(action_param: 'file_move');
_admin_addvar: 'file_copy', -override=(action_param: 'file_copy');
_admin_addvar: 'file_delete', -override=(action_param: 'file_delete');
_admin_addvar: 'file_inspect', -override=(action_param: 'file_inspect');
_admin_addvar: 'file_root', -default='/', -override=(action_param: 'file_root');
_admin_addvar: 'file_out_of_root', -override=(action_param: 'file_out_of_root');

//
// Process Action
//

if: ($groups_action >> 'Unassign');

	var: 'sql' = 'DELETE FROM security_group_file_perms WHERE id_group = ' + $groups_groupid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	_security_flushcaches;

else: ($groups_action >> 'Assign');

	var: 'sql' = 'DELETE FROM security_group_file_perms WHERE id_group = ' + $groups_groupid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	if: $file_out_of_root >> 'Y';
	
		inline: -add,
			-database=(_admin_internaldatabase),
			-table='security_group_file_perms',
			'id_group' = $groups_groupid,
			'allow_create'='Y',
			'allow_read'='Y',
			'allow_write'='Y',
			'allow_move'='Y',
			'allow_copy'='Y',
			'allow_delete'='Y',
			'allow_inspect'='Y',
			'allow_root'='/',
			'allow_out_of_root'='Y';
		/inline;

	else;

		inline: -add,
			-database=(_admin_internaldatabase),
			-table='security_group_file_perms',
			'id_group' = $groups_groupid,
			'allow_create'=$file_create,
			'allow_read'=$file_read,
			'allow_write'=$file_write,
			'allow_move'=$file_move,
			'allow_copy'=$file_copy,
			'allow_delete'=$file_delete,
			'allow_inspect'=$file_inspect,
			'allow_root'=$file_root,
			'allow_out_of_root'='N';
		/inline;

	/if;

	_security_flushcaches;

else: $groups_action >> 'Allow All';

	var: 'sql' = 'DELETE FROM security_group_file_perms WHERE id_group = ' + $groups_groupid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	inline: -add,
		-database=(_admin_internaldatabase),
		-table='security_group_file_perms',
		'id_group' = $groups_groupid,
		'allow_create'='Y',
		'allow_read'='Y',
		'allow_write'='Y',
		'allow_move'='Y',
		'allow_copy'='Y',
		'allow_delete'='Y',
		'allow_inspect'='Y',
		'allow_root'=$file_root,
		'allow_out_of_root'=$file_out_of_root;
	/inline;

	_security_flushcaches;

else: $groups_action >> 'Deny All';

	var: 'sql' = 'DELETE FROM security_group_file_perms WHERE id_group = ' + $groups_groupid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	inline: -add,
		-database=(_admin_internaldatabase),
		-table='security_group_file_perms',
		'id_group' = $groups_groupid,
		'allow_create'='N',
		'allow_read'='N',
		'allow_write'='N',
		'allow_move'='N',
		'allow_copy'='N',
		'allow_delete'='N',
		'allow_inspect'='N',
		'allow_root'=$file_root,
		'allow_out_of_root'=$file_out_of_root;
	/inline;

	_security_flushcaches;

/if;


//
// Find File Permissions for Current Group
//

var: 'file_create'='N';
var: 'file_read'='N';
var: 'file_write'='N';
var: 'file_move'='N';
var: 'file_copy'='N';
var: 'file_delete'='N';
var: 'file_inspect'='N';
var: 'file_root'='/';
var: 'file_out_of_root'='N';

if: ($groups_groupdetail != null);
	var: 'sql' = 'SELECT * FROM security_group_file_perms ' +
		'WHERE id_group = ' + $groups_groupdetail->(find: 'id');

	inline: -database=(_admin_internaldatabase), -sql=$sql;
		if: (found_count) > 0;
			var: 'file_create'=(field: 'allow_create');
			var: 'file_read'=(field: 'allow_read');
			var: 'file_write'=(field: 'allow_write');
			var: 'file_move'=(field: 'allow_move');
			var: 'file_copy'=(field: 'allow_copy');
			var: 'file_delete'=(field: 'allow_delete');
			var: 'file_inspect'=(field: 'allow_inspect');
			var: 'file_root'=(field: 'allow_root');
			var: 'file_out_of_root'=(field: 'allow_out_of_root');
		/if;
	/inline;

/if;

?>
