<?LassoScript

	define_tag: '_debug', -priority='replace';
	
		return: '';

		var: '_debug_count' = (integer: (var: '_debug_count')) + 1;
		local: 'colors'=(array: 'blue','purple','red','orange','green');
		local: 'output' = '<font size="1" color="' + #colors->(get: ($_debug_count % #colors->size) + 1) + '" face="Verdana">';
		iterate: (params), (local: 'temp');
			#output += #temp + ' ';
		/iterate;
		#output += '</font><br>';
		return: #output;
	/define_tag;
	
	define_tag: '_admin_nocache', -priority='replace';
		$__http_header__ += 'Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n';
		$__http_header__ += 'Last-Modified: ' + (Date_LocaltoGMT: date )->(format:'%a, %d %m %Y %H:%M:%S') + ' GMT\r\n';
		$__http_header__ += 'Cache-Control: no-store, no-cache, must-revalidate\r\n';
		$__http_header__ += 'Cache-Control: post-check=0, pre-check=0\r\n';
		$__http_header__ += 'Pragma: no-cache\r\n';
	/define_tag;
	
	define_tag: '_admin_range', -required='value', -required='min', -required='max', -priority='replace';
		return: (math_min: #max, (math_max: #min, #value));
	/define_tag;
	
	define_tag: '_admin_array_find', -required='array', -required='pattern', -priority='replace';
		if: !(#array->(isa: 'array'));
			return: 'None';
		/if;
		protect;
			return: #array->(find: #pattern)->(get:1)->second;
	/protect;
		if: (#pattern == 0);
			return: 'None';
		/if;
		return: (string: #pattern);
	/define_tag;
	
	define_tag: '_admin_addvar', -required='name', -optional='default', -optional='session', -optional='override', -optional='force', -priority='replace';
		if: ((var_defined: #name) == false) || ((var: #name) == null);
			var: #name = '';
		/if;
		if: (local_defined: 'force');
			var: #name = #force;
		else: (local_defined: 'override') && (#override != '');
			var: #name = #override;
		else: (local_defined: 'default') && ((var: #name) == '') && (#default != '');
			var: #name = #default;
		/if;
		if: (local_defined: 'session') && (#session != '');
			session_addvar: -name=#session, #name;
		/if;
	/define_tag;
	
	define_tag: '_admin_short_cleanup', -required='output', -required='size', -priority='replace';
		local: '_output'=(string: #output);
		local: '_size'=(integer: #size);
	
		if: #_output == '';
			return: ' ';
		/if;
	
		if: #_output->length < #_size;
			#_output = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_output);
			return: #_output;
		/if;
	
		#_output = #_output->(substring:0,(#_size - 3));
		if: (#_output->(endswith: '...'));
			return: #_output;
		else: (#_output->(endswith: '..'));
			return: #_output + '.';
		else: (#_output->(endswith: '.'));
			return: #_output + '..';
		else;
			return: #_output + '...';
		/if;
	/define_tag;
	
	define_tag: '_admin_wrap_cleanup', -required='input', -required='wrap', -required='size', -priority='replace';
		local: '_input'=(string: #input);
		local: '_wrap'=(integer: #wrap);
		local: '_size'=(integer: #size);
		local: '_margin'=(integer: (#wrap / 4.0));
	
		if: #_input->length < #_wrap;
			#_input = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_input);
			return: #_input;
		/if;
	
		local: '_pattern' = '\\s*(.{0,' + (#_wrap - #_margin) + '}\\w{0,' + (#_margin) + '})';
		local: '_lines' = (string_findregexp: #_input, -find=#_pattern);
	
		local: '_output' = '';
		local: '_count' = 0;
		loop: -loopfrom=2, -loopto=#_lines->size, -loopincrement=2;
			#_output += (encode_html: #_lines->(get: loop_count)) + '<br>';
			#_count += 1;
			if: #_count >= #_size;
				loop_abort;
			/if;
		/loop;
	
		if: #_lines->size > (#_count * 2);
			#_output += '...';
		else;
			#_output->(removetrailing: '<br>');
		/if;
	
		#_output = (string_replace: -find='href', -replace='&#104;&#114;&#101;&#102;', #_output);
	
		return: #_output;
	/define_tag;
	
	define_tag:'_admin_ifempty', -priority='replace';
		if: params->(get:1) != '';
			return: params->get:1;
		else;
			return: params->get:2;
		/if;
	/define_tag;
	
	define_tag:'_admin_ifnull', -priority='replace';
		if: params->(get:1) != null;
			return: params->get:1;
		else;
			return: params->get:2;
		/if;
	/define_tag;
	
	define_tag: '_admin_connectortype', -priority='replace', -required='name';
		if: (#name >> 'com.microsoft.jdbc.sqlserver.SQLServerDriver');
			return: 'blueworld sqlserver jdbc';
		else: (#name >> 'fmremotedatasource');
			return: 'blueworld filemaker';
		else: (#name >> 'internalmysqlds');
			return: 'internal mysql';
		else: (#name >> 'mysqlds');
			return: 'blueworld mysql';
		else: (#name >> 'jdbc') || (#name >> 'driver');
			return: 'thirdparty jdbc';
		else;
			return: 'thirdparty';
		/if;
	/define_tag;

	_admin_addvar: '__admin_connectors_array', -default=null;
	_admin_addvar: '__admin_connector_id', -default=null;
	_admin_addvar: '__admin_hosts_array', -default=null;
	_admin_addvar: '__admin_host_id', -default=null;
	_admin_addvar: '__admin_databases_array', -default=null;
	_admin_addvar: '__admin_database_id', -default=null;
	_admin_addvar: '__admin_tables_array', -default=null;
	_admin_addvar: '__admin_table_id', -default=null;
	_admin_addvar: '__admin_fields_array', -default=null;
	_admin_addvar: '__admin_groups_array', -default=null;
	_admin_addvar: '__admin_users_array', -default=null;
	
?>