<?LassoScript

define_tag:'soap_definecall', -required='named', -type='string', 
						-required='wsdl', -type='xml',
						-required='opname', -type='string',
						-optional='namespace', -type='string',
						-optional='postproc',
						-description='Maps a SOAP operation to a Lasso tag name. Calling the tag will invoke the SOAP operation and return the response.';
    xsd_loadSchema(#wsdl);
    local:'op' = @wsdl_getOperation(#wsdl, #opname);
    fail_if: #op == null, -1, 'Could not find the requested operation.';
    
    local:'soapaction' = @wsdl_getOpSoapAction(#op);
    local:'msgtypes' = @wsdl_getOpMessageTypes(#op);
    
    local:'infomap'=map;
    fail_if:#msgtypes == null, -1, 'Could not get message types.';
    
    local:'inputparts' = wsdl_getMessageParts(#wsdl, xsd_ref(#msgtypes->first)->name);
    local:'outputparts' = wsdl_getMessageParts(#wsdl, xsd_ref(#msgtypes->second)->name);
    return:#inputparts;
/define_tag;

?>