<?LassoScript

{

//
// Recursion Limit
//

	local: 'recursion_limit'=null;
	inline: -search,
			-database='lasso_internal', 
			-table='global_prefs',
			-keyfield='store_key',
			-keyvalue='recursion_limit';
		if: (found_count) > 0;
			local: 'recursion_limit' = (field: 'data');
		/if;
	/inline;
	if: #recursion_limit === null;
		local: 'recursion_limit' = 50;
	/if;
	protect;
		_recursion_limit: (integer: #recursion_limit);
		if: (integer: #recursion_limit) > 0;
			Log_Warning: 'Recursion Limit: ' + (integer: #recursion_limit) + '.';
		else;
			Log_Warning: 'Recursion Limit: No Limit.';
		/if;
	/protect;


//
// Format File Execution Time Limit
//

	local: 'execution_timelimit'=null;
	inline: -search,
			-database='lasso_internal', 
			-table='global_prefs',
			-keyfield='store_key',
			-keyvalue='execution_timelimit';
		if: (found_count) > 0;
			local: 'execution_timelimit' = (field: 'data');
		/if;
	/inline;
	if: #execution_timelimit === null;
		local: 'execution_timelimit' = 600;
	/if;
	protect;
		_execution_timelimit: (integer:#execution_timelimit);
		if: (integer: #execution_timelimit) > 0;
			Log_Warning: 'Format File Execution Time Limit: ' + (integer:#execution_timelimit) + ' seconds.';
		else;
			Log_Warning: 'Format File Execution Time Limit: No Limit.';
		/if;
	/protect;

//
// Default Page Encoding
//

	local: 'default_page_encoding'=null;
	inline: -search,
			-database='lasso_internal', 
			-table='global_prefs',
			-keyfield='store_key',
			-keyvalue='default_page_encoding';
		if: (found_count) > 0;
			local: 'default_page_encoding' = (field: 'data');
		/if;
	/inline;
	if: #default_page_encoding === null;
		local: 'default_page_encoding' = 'utf-8';
	/if;
	global: '__encoding__' = (string: #default_page_encoding);
	Log_Warning: 'Default Page Encoding: ' + (string: #default_page_encoding) + '.';

}->run;

//
// Insert literals for 'all', 'eq', 'neq', etc. into tag map
//

if: (var_defined: '__tags__');
	$__tags__->(insert: 'all'='all');
	$__tags__->(insert: 'and'='and');
	$__tags__->(insert: 'bw'='bw');
	$__tags__->(insert: 'cn'='cn');
	$__tags__->(insert: 'eq'='eq');
	$__tags__->(insert: 'ew'='ew');
	$__tags__->(insert: 'ft'='ft');
	$__tags__->(insert: 'gt'='gt');
	$__tags__->(insert: 'gte'='gte');
	$__tags__->(insert: 'lt'='lt');
	$__tags__->(insert: 'lte'='lte');
	$__tags__->(insert: 'neq'='neq');
	$__tags__->(insert: 'not'='not');
	$__tags__->(insert: 'nrx'='nrx');
	$__tags__->(insert: 'or'='or');
	$__tags__->(insert: 'rx'='rx');
	$__tags__->(insert: '12hour'='12hour');
	$__tags__->(insert: '24hour'='24hour');
/if;

?>
