<?LassoScript

// Global.lasso
//
// This file defines two tags which make working with global variables easier
//
// [Global] can be used to set and retrieve global variables like [Variable].
// [Global_Defined] can be used to check whether a global has been defined.
//

define_tag: 'global', -priority='replace';
	iterate: (params), (local: 'param');
		if: (#param->(isa: 'pair'));
				globals->(insert: #param->first = #param->second);
		else;
			if: !(globals->keys >> #param);
				globals->(insert: #param = null);
			/if;
			return: (globals->(find: #param));
		/if;
	/iterate;
/define_tag;

define_tag: 'global_defined', -required='param', -priority='replace';
	if: (globals->keys >> #param);
		return: true;
	/if;
	return: false;
/define_tag;

?>