<?LassoScript

define_tag: 'named_param', -required='name', -priority='replace';
	iterate: params_up, (local: 'temp');
		if: #temp->(isa: 'pair') && (#temp->first == #name);
			return: #temp->second;
		/if;
	/iterate;
	return: null;
/define_tag;

// file uploads
define_tag: 'file_uploads', -priority='replace';
	if: !var_defined:'_uploads_';
		var:'_uploads_'=array;
	/if;
	return: $_uploads_;
/define_tag;

?>

<!--
	Tags for getting various http request and Lasso parameters

	History:

		06/15/2001	AK - added array param caching
		05/29/2001	AK - initial coding

-->

<?lassoscript

//Convert args to pair array:
define_tag:'_chop_args', -priority='replace';
	local:'out' = (array);
	if: ((params)->(size) == 2) && (params)->(get:1)->(length);
		local:'delim' = (params)->(get:2),'temp'='';
		#out = (params)->(get:1)->(split:#delim);

		loop:(#out->size);
			#temp = #out->(get:loop_count)->(split:'=');
			if: (#temp->(size) == 2);
				#out->(get:loop_count) = (pair:(decode_url:#temp->(get:1)) = (decode_url:#temp->(get:2)));
			else: (#temp->(size) == 1);
				#out->(get:loop_count) = (pair:(decode_url:#temp->(get:1)) = '');
			/if;
		/loop;
	/if;
	return:#out;
/define_tag;


//
// Request Params:
//

//QUERY_STRING
define_tag:'Client_GetArgs', -priority='replace';
	return: (_request_param:'kfor');
/define_tag;


//QUERY_STRING args returned as array
define_tag:'Client_GetParams', -priority='replace';
	if: !(var_defined:'__client_getparams__');
		var:'__client_getparams__' = (_chop_args:(_request_param:'kfor'),'&');
		$__client_getparams__->freezevalue;
	/if;
	return: (var:'__client_getparams__');
/define_tag;

//post args
define_tag:'Client_PostArgs', -priority='replace';
	return: (_request_param:'post');
/define_tag;

//same as above, returned as array
define_tag:'Client_PostParams', -priority='replace';
	if: !(var_defined:'__client_postparams__');
		var:'__client_postparams__' = (_chop_args:(_request_param:'post'),'&');
		$__client_postparams__->freezevalue;
	/if;
	return: (var:'__client_postparams__');
/define_tag;

//multiple cookies returned
//in a ';'-separated string
define_tag:'Client_CookieList', -priority='replace';
	return: (_request_param:'koky');
/define_tag;

//array containing cookie name/value pairs
define_tag:'Client_Cookies', -priority='replace';
	if: !(var_defined:'__client_cookies__');
		var:'__client_cookies__' = (_chop_args:(_request_param:'koky'),'; ');
		$__client_cookies__->freezevalue;
	/if;
	return: (var:'__client_cookies__');
/define_tag;

//REQUEST_METHOD
define_tag:'Client_FormMethod', -priority='replace';
	return: (_request_param:'meth');
/define_tag;

//CONTENT_TYPE
define_tag:'Client_ContentType', -priority='replace';
	return: (_request_param:'ctyp');
/define_tag;

//CONTENT_LENGTH
define_tag:'Client_ContentLength', -priority='replace';
	return: (integer:_request_param:'CLen');
/define_tag;

//HTTP_USER_AGENT
define_tag:'Client_Browser', -priority='replace';
	return: (_request_param:'Agnt');
/define_tag;


//returns site name
//define_tag:'Response_Site', -priority='replace';
//	return: (_request_param:'Site');
///define_tag;

//PATH_INFO
define_tag:'Response_Path', -priority='replace';
	return: (_request_param:'SPth');
/define_tag;

//realm name
define_tag:'Response_Realm', -priority='replace';
	return: (_request_param:'CRlm');
/define_tag;

//PATH_TRANSLATED
// This was moved into native code KRJ 12/11/2001
//define_tag:'Response_LocalPath', -priority='replace';
//	return: (_request_param:'RsFP');
///define_tag;

?>
