<?LassoScript
	
	// [XML_Extract: -XML='xml data', -XPath='xpath']
	// [XML_Extract: -File='path to xml file', -XPath='xpath']
	//
	// Other parameter names are allowed since the documentation for LP6 was unclear.

	Define_Tag: 'XML_Extract',
			-Optional='XML',
			-Optional='XPath',
			-Optional='XMLData',
			-Optional='File',
			-Optional='XMLFile',
			-Priority='replace';
		
		if: (local_defined: 'xml');
			if: (#xml->isa: 'xml');
				local: 'data' = #xml;
			else;
				local: 'data' = (xml: #xml);
			/if;
		else: (local_defined: 'xmldata');
			if: (#xmldata->isa: 'xml');
				local: 'data' = #xmldata;
			else;
				local: 'data' = (xml: #xmldata);
			/if;
		else: (local_defined: 'file');
			local: 'data' = (xml: (include_raw: #file));
		else: (local_defined: 'xmlfile');
			local: 'data' = (xml: (include_raw: #xmlfile));
		else;
			fail: (-1), '[XML_Extract] No -XML or -File parameter was specified.';
		/if;
			
		if: (local_defined: 'xpath');
			local: 'path' = (string: #xpath);
		else;
			fail: (-1), '[XML_Extract] No -XPath parameter was specified.';
		/if;

		return: #data->(extract: #path);
		
	/Define_Tag;
	
	// [XML_Transform: -XML='xml data', -XSL='xpath']
	// [XML_Transform: -File='path to xml file', -XSL='style sheet']
	// [XML_Transform: -XML='xml data', -XSLFile='path to style sheet']
	//
	// Other parameter names are allowed since the documentation for LP6 was unclear.

	Define_Tag: 'XML_Transform',
			-Optional='XML',
			-Optional='XSL',
			-Optional='XMLData',
			-Optional='File',
			-Optional='XMLFile',
			-Optional='XSLT',
			-Optional='XSLFile',
			-Optional='XSLTFile',
			-Priority='replace';
		
		if: (local_defined: 'xml');
			if: (#xml->isa: 'xml');
				local: 'data' = #xml;
			else;
				local: 'data' = (xml: #xml);
			/if;
		else: (local_defined: 'xmldata');
			if: (#xmldata->isa: 'xml');
				local: 'data' = #xmldata;
			else;
				local: 'data' = (xml: #xmldata);
			/if;
		else: (local_defined: 'file');
			local: 'data' = (xml: (include_raw: #file));
		else: (local_defined: 'xmlfile');
			local: 'data' = (xml: (include_raw: #xmlfile));
		else;
			fail: (-1), '[XML_Transform] No -XML or -File parameter was specified.';
		/if;
			
		if: (local_defined: 'xsl');
			local: 'style' = (string: #xsl);
		else: (local_defined: 'xslt');
			local: 'style' = (string: #xslt);
		else: (local_defined: 'xslfile');
			local: 'style' = (include_raw: #xslfile);
		else: (local_defined: 'xsltfile');
			local: 'style' = (include_raw: #xsltfile);
		else;
			fail: (-1), '[XML_Transform] No -XSL parameter was specified.';
		/if;

		return: #data->(transform: #style);
		
	/Define_Tag;

?>
