#!/bin/sh

running=`/sbin/pidof LassoService`

if [ $running ]; then
	echo ""
	echo "Another instance of Lasso Service is already running."
	echo ""
	echo "Please use stopLassoService.sh to stop Lasso Service."
	echo ""
else

	if [ `id -u` != 0 ]; then
		echo ""

		if [ -f /usr/bin/sudo ]; then
			/usr/bin/sudo -p "You must have administrator privileges to run this script.  Enter the password for %u: " "$0"
		else
			echo "This script must be run by the system administrator."
		fi

	else
		echo ""

		if [ "$1" = "safe" ]; then
			TYPE="SAFE"
		else
			TYPE="NORMAL"
		fi

		echo -n "Starting Lasso Service..."

		if [ "$TYPE" = "SAFE" ]; then
			chmod 000 /usr/local/Lasso\ Professional\ 7/LassoModules/*
		else
			chmod 775 /usr/local/Lasso\ Professional\ 7/LassoModules/*
		fi

		/usr/local/Lasso\ Professional\ 7/Admin/LassoService.sh 2> /dev/null >> /dev/null &

		ctime=120
		counter=0
		lassoup=0

		while (test $counter -lt $ctime && ! test -f /tmp/LassoService.pid)
		do
			echo -n .
			sleep 1
			counter=$((counter+1))
			if ( test -f /tmp/LassoService.pid ) then
				lassoup=1
			fi
		done

		lassoservice=`cat /tmp/LassoService.pid`

		echo "Done [$lassoservice]"
		echo ""

		if ( test $lassoup = 1 || test -f /tmp/LassoService.pid ) then
			echo "Lasso Service has been started."
			echo ""
			echo "Use stopLassoService.sh to stop Lasso Service."
		else
			echo "Lasso Service did not successfully start in the $ctime second wait time. This could be caused by a datasource host timing out, or the Lasso Service suffered a critical error during startup. Run consoleLassoService.sh for more information."
		fi
	fi

fi
